import * as THREE from "three";
import { Canvas } from "@react-three/fiber";
import { useLoader,useFrame } from "@react-three/fiber";
import React, { useMemo, Suspense, memo } from "react";
import { GLTFLoader } from "three/examples/jsm/loaders/GLTFLoader";
import { useGLTF } from "@react-three/drei";

const Mesh = (props) => {
  const model = useGLTF(props.path);

  let mixer = new THREE.AnimationMixer(model.scene);
  model.animations.forEach((clip)=>{
    const action = mixer.clipAction(clip);
    action.play();
  })

  useFrame((scene,delta)=>{
    mixer?.update(delta)
  })

  return (
    <primitive object={model.scene} scale={0.007} position={[20,0.35,-8]}/>
  );
};

function Jixiebi(props) {
  return (
    <Suspense fallback={null}>
      <Mesh
        {...props}
        path={require(`@/assets/gltf/basic_robot_arm.glb`)}
      />
    </Suspense>
  );
}

export default memo(Jixiebi)

useGLTF.preload(require(`@/assets/gltf/basic_robot_arm.glb`));
